
// CopyFiles.cpp : implementation file
//

#include "stdafx.h"
#include "khan.h"
#include "CopyFiles.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif




/////////////////////////////////////////////////////////////////////////////
// CCopyFiles dialog


CCopyFiles::CCopyFiles(CWnd* pParent /*=NULL*/)
	: CDialog(CCopyFiles::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCopyFiles)
	m_strHeader = _T("");
	m_strFolderPath = _T("");
	m_bUseNames = FALSE;
	m_bUseTitles = FALSE;
	//}}AFX_DATA_INIT

	m_nFilesCopied = 0;
	m_strMessage.Empty();
	m_hCopyThread = NULL;
	m_dirFrom.Empty();;
	m_dirTo.Empty();;
	m_useTitles = FALSE;
	m_copyThreadParam.Zero();
}


void CCopyFiles::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCopyFiles)
	DDX_Control(pDX, IDOK, m_ctrlClose);
	DDX_Control(pDX, IDC_PROG_COPY, m_ctrlProgress);
	DDX_Control(pDX, IDC_CHECK_TITLES, m_ctrlUseTitles);
	DDX_Control(pDX, IDC_CHECK_FILE_NAMES, m_ctrlUseNames);
	DDX_Control(pDX, IDC_BUTTON_COPY, m_ctrlCopy);
	DDX_Control(pDX, IDC_EDIT_TO, m_ctrlEditTo);
	DDX_Text(pDX, IDC_STATIC_COPY, m_strHeader);
	DDX_Text(pDX, IDC_EDIT_TO, m_strFolderPath);
	DDX_Check(pDX, IDC_CHECK_FILE_NAMES, m_bUseNames);
	DDX_Check(pDX, IDC_CHECK_TITLES, m_bUseTitles);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CCopyFiles, CDialog)
	//{{AFX_MSG_MAP(CCopyFiles)
	ON_BN_CLICKED(IDC_BUTTON_BROWSE, OnButtonBrowse)
	ON_BN_CLICKED(IDC_BUTTON_COPY, OnButtonCopy)
	ON_BN_CLICKED(IDC_CHECK_FILE_NAMES, OnCheckFileNames)
	ON_BN_CLICKED(IDC_CHECK_TITLES, OnCheckTitles)
	//}}AFX_MSG_MAP

	ON_MESSAGE(WM_USER_COPY_THREAD, OnCopyThreadMessage)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCopyFiles message handlers

BOOL CCopyFiles::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here

	int sz = m_itemAr.GetSize();
	m_strHeader.Format(_T("Copy %d video files to the destination folder below. ")
					   _T("Note administartive privilidges may be required. ")
					   _T("See the help file for more information."), sz);

	// Set button text.
	m_ctrlCopy.SetWindowText(COPYSTR);

	// Disable button till folder gotten.
	m_ctrlCopy.EnableWindow(FALSE);

	// Check names.
	m_bUseNames = TRUE;

	// Set ctrls.
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CCopyFiles::OnButtonBrowse() 
{
	BROWSEINFO bi;
	ZeroMemory(&bi, sizeof(bi));
	TCHAR szDisplayName[MAX_PATH];
	TCHAR szInitialDir[MAX_PATH];
	szDisplayName[0] = '\0';

	bi.hwndOwner		= GetSafeHwnd();
	bi.pszDisplayName	= szDisplayName;
	bi.pidlRoot			= NULL;
	bi.lpszTitle		= _T("Copy files to folder:");
#if VS2005	
	// Allow create folder - Shell32.dll Version 5.0	
	bi.ulFlags			= BIF_RETURNONLYFSDIRS | BIF_EDITBOX | BIF_VALIDATE | BIF_USENEWUI;
#else
	bi.ulFlags			= BIF_RETURNONLYFSDIRS | BIF_EDITBOX | BIF_VALIDATE;
#endif
	bi.lpfn				= BrowseCallbackProc;
	bi.lParam			= NULL;
	bi.iImage			= 0;

	// Browse.
	LPITEMIDLIST pIIL = ::SHBrowseForFolder(&bi);

	// Check return.
#if VS2005	
	BOOL bRet = ::SHGetPathFromIDList(pIIL, (LPWSTR)&szInitialDir);	
#else	
	BOOL bRet = ::SHGetPathFromIDList(pIIL, (unsigned short*)&szInitialDir);
#endif
	if(bRet)
	{
		CString str = szInitialDir; 
		if(!str.IsEmpty())
		{
			// Set member.
			m_strFolderPath = str;
			UpdateData(FALSE);
			m_ctrlCopy.EnableWindow(TRUE);
		}

		// Clean up.
		LPMALLOC pMalloc;
		HRESULT hr = SHGetMalloc(&pMalloc);
		if(hr == NOERROR)
		{
			pMalloc->Free(pIIL);
			pMalloc->Release();
		}
	}	
}

// SHBrowseForFolder callback.
int CALLBACK BrowseCallbackProc(HWND hwnd, UINT uMsg, 
                                LPARAM lParam, LPARAM lpData)
{
	switch (uMsg)
	{
		case BFFM_VALIDATEFAILED:
		{
			AfxMessageBox(_T("Cannot create folders"));
		}
		default:
		return 0;
	}
}

// Check boxes.
void CCopyFiles::OnCheckFileNames() 
{
	if(m_ctrlUseNames.GetCheck())
		m_ctrlUseTitles.SetCheck(0);
	else
		m_ctrlUseTitles.SetCheck(1);
	// Save checks.
	UpdateData();	
}
void CCopyFiles::OnCheckTitles() 
{
	if(m_ctrlUseTitles.GetCheck())
		m_ctrlUseNames.SetCheck(0);
	else
		m_ctrlUseNames.SetCheck(1);
	// Save checks.
	UpdateData();	
}

// Close button pressed.
void CCopyFiles::OnOK() 
{
	// This dialog contains members passed via ptr to the
	// worker thread. Must ensure thread has completed.
	// Note: should not have thread running here due to
	// disabled close button.
	if(m_hCopyThread)
	{
		::WaitForSingleObject(m_hCopyThread, INFINITE);
		::CloseHandle(m_hCopyThread);
		m_hCopyThread = NULL;
	}	
	CDialog::OnOK();
}


// Copy / Cancel pressed..
void CCopyFiles::OnButtonCopy() 
{
	// Get button text.
	CString s;
	m_ctrlCopy.GetWindowText(s);

	// If copying.
	if(s == COPYSTR)
	{
		// Set cancel button.
		m_ctrlCopy.SetWindowText(CANCELSTR);

		// Disable close button.
		m_ctrlClose.EnableWindow(FALSE);

		// Set controls.
		UpdateData(FALSE);

		// Launch thread.
		if(CopyVideoFiles())
		{
			// OnThreadMessage() will finish up.
			return;
		}
		// Thread launch failed.
		else
		{
			m_strHeader = _T("Could not copy files - program error 2.");
			m_ctrlCopy.EnableWindow(FALSE);
			m_ctrlClose.EnableWindow(TRUE);
			UpdateData(FALSE);
			return;
		}
	}
	// Canceling.
	else
	{
		// Set event. OnThreadMessage() will finish up.
		m_event.SetEvent();
		m_ctrlCopy.EnableWindow(FALSE);
	}	
}

///////////////////////////////////////////////////////////
// Copy thread.

BOOL CCopyFiles::CopyVideoFiles()
{
	// Ensure not in use.
	if(m_hCopyThread != NULL)
		return FALSE;

	// Get Doc.
	CDoc * pDoc = ((CApp*)AfxGetApp())->m_pDoc;
	if(!pDoc)
	{
		m_strHeader = _T("Could not copy files - program error.");
		m_ctrlCopy.EnableWindow(FALSE);
		UpdateData(FALSE);
		return FALSE;
	}
	int sz = m_itemAr.GetSize();

	// Set local members.
	m_dirFrom	=  pDoc->m_videoStorePath;
	m_dirTo		=  m_strFolderPath;
	m_useTitles	=  m_bUseTitles;

	// If using Titles, rework array.
	if(m_useTitles)
	{
		for(int i = 0; i < sz; i++)
		{
			// Clean invalid chars and trim to MAX_TITLE_LEN chars.
			CleanTitlePath(m_itemAr[i].m_title, MAX_TITLE_LEN);
			// Append extension.
			m_itemAr[i].m_title += _T(".mp4");
		}
	}

	// Prepare progress.
	m_ctrlProgress.SetRange32(0, sz);
	m_ctrlProgress.SetStep(1);

	// Set event nonsignaled.
	m_event.ResetEvent();

	// Set param member.
	m_copyThreadParam.hwndDlg	 = GetSafeHwnd();
	m_copyThreadParam.pEvent	 = &m_event;
	m_copyThreadParam.bUseTitles = &m_useTitles;
	m_copyThreadParam.dirFrom	 = &m_dirFrom;
	m_copyThreadParam.dirTo		 = &m_dirTo;
	m_copyThreadParam.itemAr	 = &m_itemAr;

	// Start worker thread in suspended state.
	CWinThread * pThread = AfxBeginThread(CopyFilesThread, 
										  &m_copyThreadParam,
										  THREAD_PRIORITY_NORMAL, 
										  0, 
										  CREATE_SUSPENDED);
	// Copy handle to m_hCopyThread.
	::DuplicateHandle(GetCurrentProcess(),
					  pThread->m_hThread, 
					  GetCurrentProcess(), 
					  &m_hCopyThread,
					  0, 
					  FALSE, 
					  DUPLICATE_SAME_ACCESS);
	// Start thread.
	pThread->ResumeThread();

	// OK
	return TRUE;
}


// Copy files thread function.
UINT CopyFilesThread(LPVOID pParam)
{
	// Copy param data.
	COPYPARAM param = *(COPYPARAM *) pParam;

	CString fromPath, toPath, s;
	UINT nCopied = 0;

	// Get directories.
	CString fromDir = *param.dirFrom;
	fromDir += _T("\\");
	CString toDir = *param.dirTo;
	toDir += _T("\\");

	int sz = param.itemAr->GetSize();
	CListItem item;
	BOOL useTitles = *param.bUseTitles;

	CApp * pApp = ((CApp*)AfxGetApp());
	CString errMsg;

	// Copy files.
	for(int i = 0; i < sz; i++)
	{
		// Copy the item.
		item = param.itemAr->GetAt(i);
		
		// Path from.
		fromPath = fromDir;
		fromPath += item.m_fileName;
		//fromPath += _T("x");//test fail

		// Path to.
		toPath = toDir;
		if(useTitles)
			toPath += item.m_title;
		else
			toPath += item.m_fileName;

		// User can abort copying.
		if(::WaitForSingleObject(param.pEvent->m_hObject, 0) == WAIT_OBJECT_0) 
		{
			// Inform dlg of cancelation with COPYMSG lparam.
			::PostMessage(param.hwndDlg, WM_USER_COPY_THREAD, nCopied, cmCancel);
			return 1;
		}

		// Attempt copy.
		if(CopyFile(fromPath, toPath, FALSE))
		{
			// Inform dlg of copy with COPYMSG lparam.
			::PostMessage(param.hwndDlg, WM_USER_COPY_THREAD, 0, cmStepIt);
			nCopied ++;
		}
		// Error
		else
		{
			DWORD err = GetLastError();

			// Format last error.
			LPVOID lpMsgBuf;
			FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER |
						  FORMAT_MESSAGE_FROM_SYSTEM	 |
						  FORMAT_MESSAGE_IGNORE_INSERTS,
						  NULL,
						  err,
						  MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
						  (LPTSTR) &lpMsgBuf,
						  0,
						  NULL);

			// Format err msg.
			errMsg.Format(_T("%s\n%s"), item.m_title, lpMsgBuf);
			errMsg.TrimRight();

			// Set message in CApp.
			if(pApp)
				pApp->SetThreadMessage(errMsg);

			// Inform dlg of failure with COPYMSG lparam.
			::PostMessage(param.hwndDlg, WM_USER_COPY_THREAD, nCopied, cmError);

			// Clean up.
			LocalFree(lpMsgBuf);

			// Bail.
			return 0;
		}
	}
	// Done
	//.
	// Inform dlg of completion with COPYMSG lparam.
	::PostMessage(param.hwndDlg, WM_USER_COPY_THREAD, nCopied, cmDone);
	return 1;
}

// Message from copy thread.
LRESULT CCopyFiles::OnCopyThreadMessage(WPARAM wParam, LPARAM lParam)	// WM_USER_COPY_THREAD
{

	// Step the progress.
	if(lParam == cmStepIt)
	{
		m_ctrlProgress.StepIt();
		return 0;
	}

	// Else shut down the Download worker thread.
	if(m_hCopyThread)
	{
		::WaitForSingleObject(m_hCopyThread, INFINITE);
		::CloseHandle(m_hCopyThread);
		m_hCopyThread = NULL;
	}

	UINT nCopied = wParam;
	m_nFilesCopied = nCopied;	// used by CListFiles

	// Copy thread finisished.
	if(lParam == cmDone)
	{
		m_strHeader.Format(_T("%d video files copied."), nCopied);
	}
	// User canceled.
	else if(lParam == cmCancel)
	{
		m_strHeader.Format(_T("Copy video files canceled.\n%d video files copied."), nCopied);
	}
	// Error.
	else if(lParam == cmError)
	{
		CString errMsg;
		((CApp*)AfxGetApp())->GetThreadMessage(errMsg);
		// Error shows Khan Title for failed copy.
		m_strHeader.Format(_T("Error copying the video file:\n%s\n%d video files copied."), 
								errMsg, nCopied);
	}

	// Zero progress.
	m_ctrlProgress.SetPos(0);

	// Enable close button.
	m_ctrlClose.EnableWindow(TRUE);

	// Disable copy button.
	m_ctrlCopy.EnableWindow(FALSE);

	UpdateData(FALSE);

	return 0;
}

////////////////////////////////////////////////////////////////
// Helpers

// Loose invalid win32 file path chars and limit length to maxLen.
void CCopyFiles::CleanTitlePath(CString & str, int maxLen)
{
	TCHAR c;
	CString s;
	int len = str.GetLength();
	for(int i = 0; i < len; i++)
	{
		c = str[i];

		// Stop at max.
		if(i > maxLen)
			break;

		// None before 32, replace with a space.
		if(c < 32)
		{
			s += _T(' ');
			continue;
		}
		// Replace invalids with a space, or accept.
		switch(c)
		{
			// Others, replace with a space.
			case 34:	// "
			case 42:	// *
			case 47:	// /
			case 58:	// :
			case 60:	// <
			case 62:	// >
			case 63:	// ?
			case 92:	// back slash
			case 124:	// |
			//case 46:	// . period
			//case 32:	// space - allowed in between but not at end
				s += _T(' ');
				break;

			// OK.
			default:
				s += c;
				break;
		}
	}
	// Set new string.
	str = s;
}

