
/*	Copyright (C) G. Jespersen
	See Licence.txt.*/

#if !defined KHAN_INET_H
#define KHAN_INET_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Stdafx.h"
#include <afxinet.h>

class CKnanInet : public CInternetSession 
{
public:
	CKnanInet(THREADPARAM & param);	// For Khan Update & Video Download
	CKnanInet();					// For video file availability test

	~CKnanInet();

	virtual void OnStatusCallback(DWORD dwContext, 
								  DWORD dwInternetStatus,
								  LPVOID lpvStatusInformation, 
								  DWORD dwStatusInformationLength);

	BOOL GetKhanLibraryData(CString tempFilePath, int progBytes);
	BOOL GetVideoFiles(CString & errMsg);
	BOOL TestInetStream(CString url, CString & errMsg);		// 05/15 reuse post fastly issue

	// App Update.
	BOOL GetAppUpdate();
	BOOL GetAppUpdateTux();

private:
	void ShowStatus(CString strStatus);
	void SetKBps(double KBps);
	void SetProgressRange(int upper);
	void SetProgressPos(int pos);
	void SetProgress2Range(int upper);
	void SetProgress2Pos(int pos);

	// Not used
	BOOL Convert(CString unixPath, CString dosPath);
	BOOL Convert2(CString unixPath, CString dosPath);

	
public:	// Attributes

private:

	// Local thread param
	THREADPARAM m_params;

	// Accumulated status string data.
	CString m_strStatus;
};

#endif //KHAN_INET_H
