
/*	Copyright (C) G. Jespersen
	See Licence.txt.*/

// KhanTreeCtrl.cpp : implementation file
//

#include "stdafx.h"
#include "khan.h"
#include "KhanTreeCtrl.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CKhanTreeCtrl


CKhanTreeCtrl::CKhanTreeCtrl()
{
}

CKhanTreeCtrl::~CKhanTreeCtrl()
{
}

BEGIN_MESSAGE_MAP(CKhanTreeCtrl, CTreeCtrl)
	//{{AFX_MSG_MAP(CKhanTreeCtrl)
	ON_WM_MOUSEMOVE()
	ON_NOTIFY_REFLECT(NM_RCLICK, OnRclick)
	ON_WM_CONTEXTMENU()
	//}}AFX_MSG_MAP

//	ON_NOTIFY(TTN_POP, NULL, OnToolTipPop)
//	ON_NOTIFY(TTN_SHOW, NULL, OnToolTipShow)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKhanTreeCtrl message handlers

BOOL CKhanTreeCtrl::PreCreateWindow(CREATESTRUCT& cs) 
{
	// Set styles.
/*	cs.style =  WS_VISIBLE			| 
				WS_CHILD			| 
				WS_BORDER			|
				WS_VSCROLL			|
				WS_HSCROLL			|
			//	WS_EX_CONTROLPARENT	|
				TVS_HASBUTTONS		| 
				TVS_LINESATROOT		| 
				TVS_HASLINES		|
				TVS_SHOWSELALWAYS   |
				TVS_INFOTIP			|
				TVS_FULLROWSELECT	|
				TVS_DISABLEDRAGDROP;*/

	return CTreeCtrl::PreCreateWindow(cs);
}

/* 
// Note- enabling these shifts the default tool tip 
// for hidden text off the text.
//
// Info and or Tool Tip being erased when timed out.
void CKhanTreeCtrl::OnToolTipPop(NMHDR* pNMHDR, LRESULT* pResult) //TVN_GETINFOTIPW (Unicode) 
{
}

// Info and or Tool Tip being displayed.
void CKhanTreeCtrl::OnToolTipShow(NMHDR* pNMHDR, LRESULT* pResult) //TVN_GETINFOTIPW (Unicode) 
{
}
*/
// Handle the cursor being removed from a selected tree item
// which causes any Info or Tool Tip to be erased. 
void CKhanTreeCtrl::OnMouseMove(UINT nFlags, CPoint point) 
{
	CTreeCtrl::OnMouseMove(nFlags, point);
}


/////////////////////////////////////////////////////////////////
// Context menu:
//
// See MSDN: HOWTO: Display a Context Menu for CTreeCtrl Q222905
//
void CKhanTreeCtrl::OnRclick(NMHDR* pNMHDR, LRESULT* pResult) 
{
	*pResult = 0;

	TRACE(_T("CKhanTreeCtrl OnRClick\n"));

	// Send WM_CONTEXTMENU to self.
	SendMessage(WM_CONTEXTMENU, (WPARAM) m_hWnd, GetMessagePos());

	// Mark message as handled and suppress default handling
	*pResult = 1;
}

void CKhanTreeCtrl::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	// Handle in parent CTreeDialog.
	//
	// If Shift-F10
	if(point.x == -1 && point.y == -1)
		point = (CPoint)GetMessagePos();

	// Tree Ctrl coords.
	ScreenToClient(&point);

	// To CTreeDialog.
	GetParent()->PostMessage(WM_CONTEXTMENU, (WPARAM) m_hWnd, 
											  MAKELPARAM(point.x, point.y));
	return;
} 
	

