
/*	Copyright (C) G. Jespersen
	See Licence.txt.*/

// MainFrm.h : interface of the CMainFrame class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_MAINFRM_H__16B98B1A_D261_4B49_8659_4BD44ABB62C0__INCLUDED_)
#define AFX_MAINFRM_H__16B98B1A_D261_4B49_8659_4BD44ABB62C0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ControlsBar.h"


class CMainFrame : public CFrameWnd
{
	
protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:

	// Controls Bar.
	CControlsBar m_controlsBar;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized);
	//}}AFX_MSG

	afx_msg LRESULT OnUpdateFinished (WPARAM wParam, LPARAM lParam);	// WM_USER_UPDATE_FINISHED
	afx_msg LRESULT OnUpdateAborted (WPARAM wParam, LPARAM lParam);		// WM_USER_UPDATE_ABORTED
	afx_msg LRESULT OnDownloadFinished (WPARAM wParam, LPARAM lParam);	// WM_USER_DOWNLOAD_FINISHED
	afx_msg LRESULT OnDownloadAborted (WPARAM wParam, LPARAM lParam);	// WM_USER_DOWNLOAD_ABORTED
	afx_msg LRESULT OnAppUpdateFinished (WPARAM wParam, LPARAM lParam);	// WM_USER_APP_UPDATE_FINISHED
	afx_msg LRESULT OnAppUpdateAborted (WPARAM wParam, LPARAM lParam);	// WM_USER_APP_UPDATE_ABORTED
//	afx_msg LRESULT OnStreamTestFinished (WPARAM wParam, LPARAM lParam);// WM_USER_STREAM_TEST_FINISHED 5/20/15
//	afx_msg LRESULT OnStreamTestAborted (WPARAM wParam, LPARAM lParam);	// WM_USER_STREAM_TEST_ABORTED

	DECLARE_MESSAGE_MAP()

public:
	CString m_threadMsgBuf;

private:
	BOOL m_minimized;	// if minimized, pause VLC
	BOOL m_prePaused;	// if paused before minimizing
	DWORD m_activeTime;

public:

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MAINFRM_H__16B98B1A_D261_4B49_8659_4BD44ABB62C0__INCLUDED_)
